#pragma once

#include <Model3D.h>
#include <Either.h>
#include <Critical.h>

#include "EntityType.h"
#include "Area.h"

class Block;

class Entity : public Framework::Model3D
{
private:
	int id;
	const EntityType* zType;
	Framework::Critical cs;

public:
	Entity(const EntityType* zType, Framework::Model3DData* model, Framework::Model3DTextur* texture, int id);
	~Entity();

	void api(char* message);
	bool tick(double time) override;

	int getId() const;
	const EntityType* zEntityType() const;
	void lock();
	void unlock();
};